/*	duscc.h		*/
/*	Definition of DUSCC Register Address	*/

#define	CMR1	0xfdfc81	/*	Channel Mode Register1	*/
#define	CMR2	0xfdfc83	/*	Channel Mode Register2	*/
#define	S1R	0xfdfc85	/*	SYN 1/Secondary Address 1 Register	*/
#define	S2R	0xfdfc87	/*	SYN 2/Secondary Address 2 Register	*/
#define	TPR	0xfdfc89	/*	Transmitter Parameter Register	*/
#define	TTR	0xfdfc8b	/*	Transmitter Timing Register	*/
#define	RPR	0xfdfc8d	/*	Receiver Parameter Register	*/
#define	RTR	0xfdfc8f	/*	Receiver Timing Register	*/
#define	CTPRH	0xfdfc91	/*	Counter/Timer Preset Register High	*/
#define	CTPRL	0xfdfc93	/*	Counter/Timer Preset Register Low	*/
#define	CTCR	0xfdfc95	/*	Counter/Timer Control Register	*/
#define	OMR	0xfdfc97	/*	Output and Miscellaneous Register	*/
#define	CTH	0xfdfc99	/*	Counter/Timer High	*/
#define	CTL	0xfdfc9b	/*	Counter/Timer Low	*/
#define	PCR	0xfdfc9d	/*	Pin Configuration Register	*/
#define	CCR	0xfdfc9f	/*	Channel Command Register	*/
#define	TxFIFO	0xfdfca1	/*	Transmitter FIFO	*/
#define	RxFIFO	0xfdfca9	/*	Receiver FIFO	*/
#define	RSR	0xfdfcb1	/*	Receiver Status Register	*/
#define	TRSR	0xfdfcb3	/*	Transmitter and Receiver Status Register	*/
#define	ICTSR	0xfdfcb5	/*	Input and Counter/Timer Status Register	*/
#define	GSR	0xfdfcb7	/*	General Status Register	*/
#define	IER	0xfdfcb9	/*	Interrupt Enable Register	*/
#define	ICR	0xfdfcbf	/*	Interrupt Control Register	*/

#define	IVR	0xfdfcbd	/*	Interrupt Vector Register - Unmodified	*/
#define	IVRM	0xfdfcfd	/*	Interrupt Vector Register - Modified	*/


/*	Definition of DUSCC Command	*/

#define	RST_Tx		0x00	/*	Reset Tx	*/
#define	RST_TxCRC	0x01	/*	Reset TxCRC	*/
#define	EBL_Tx		0x02	/*	Enable Tx	*/
#define	DEBL_Tx		0x03	/*	Disenable Tx	*/
#define	RST_Rx		0x40	/*	Reset Rx	*/
#define	EBL_Rx		0x42	/*	Enable Rx	*/
#define	DEBL_Rx		0x43	/*	Disenable Rx	*/

/*	Definition of Vector Number for DUSCC	*/

#define	VCT	64

/*	other	symboles	*/

#define	BUFSIZE	255
#define	CR	0x0d
#ifdef	NULL
#undef	NULL
#endif
#define	NULL	0x00
#define	ACTIVE	1
