#include	<mriext.h>
#include	<string.h>
#include	"tmp_def.h"
#include	"duscc.h"

extern void	rs_snd();
extern int	inportb(),outportb(),yes(),ret();

extern char	crflg,stpflg,nextflg;
extern char	err_msg[],buffer[];
extern int	sss_ctr;		/*	interrupt counter	*/

void	sss_init();
int	sss_sel();

double	dist;		/*	distance measured by supersonic wave sensor	*/
int	h,m,l;		/*	High,Middle,Low byte of  ss sensor data		*/
int	int_sss_no;		/*	ss sensor number for interrupt			*/
int underflg;	/*	underflow flag		*/

void	sss()
{
	int	sss_no;	/*	ss sensor number		*/
	long  toc;

	rs_snd("\n **** Supersonic Wave Sensor Circuit Test **** \n");

	rs_snd("\n  IO Sub board (supersonic wave sensor circuit) is ready ? \n");
	if ( yes() != 0 ) return;

	sss_init();

	/*	[1] SSS	Select Signal Check	*/
	strcpy(err_msg,"\n ---- Check SSS:SSS Select Function ---- \n");
	rs_snd("\n [1] SSS Select Signal Check \n");
	rs_snd("\n  Set logic analizer. %% \n");
	if ( ret() != 0 ) return;

	for (sss_no=0; sss_no< SSS_MAX; sss_no++)
		if ( sss_sel(sss_no,0) != 0 )
		{
			rs_snd(err_msg);
			return;
		}

	/*	[2] SSS Send Test	*/
	strcpy(err_msg,"\n ---- Check SSS:SSS Send Circuit ---- \n");
	rs_snd("\n [2] SSS Send Test \n");
	rs_snd("\n  Conect supersonic wave sensor send circuit. \n");
	if ( ret() != 0 ) return;

	for (sss_no=0; sss_no< SSS_MAX; sss_no++)
		if ( sss_sel(sss_no,1) != 0 )
		{
			rs_snd(err_msg);
			return;
		}

	/*	[3] SSS Receive Test	*/
	strcpy(err_msg,"\n ---- Check SSS:SSS Receive Circuit ---- \n");
	rs_snd("\n [3] SSS Receive Test \n");
	rs_snd("\n  Set horns for test. Set logic analizer. %% \n");
	if ( ret() != 0 ) return;

	for (sss_no=0; sss_no< SSS_MAX; sss_no++)
		if ( sss_sel(sss_no,0) != 0 )
		{
			rs_snd(err_msg);
			return;
		}

    while(1)                 /* repeat version  1996.1.18 by nagasawa */

    {
	/*	[4] SSS Interrupt Test	*/
	strcpy(err_msg,"\n ---- Check SSS:SSS Interrupt Function ---- \n");
	rs_snd("\n [4] SSS Interrupt Test \n");
	rs_snd("\n  Set the horn, and input the sensor number >> ");

	/*	select sensor	*/
	int_sss_no = NON;
	while ( int_sss_no == NON && nextflg != ACTIVE && stpflg != ACTIVE )
	{
		int_sss_no = inp();
		if ( int_sss_no < 0 || SSS_MAX < int_sss_no ) int_sss_no = NON;
	}

       if(nextflg == ACTIVE)             /* insert 1996.1.19 by nagasawa*/
         {                               /* insert 1996.1.19 by nagasawa*/
          nextflg = !ACTIVE;             /* insert 1996.1.19 by nagasawa*/
          break;                         /* insert 1996.1.19 by nagasawa*/
          }                              /* insert 1996.1.19 by nagasawa*/
	if ( ret() != 0 ) return; 

	sss_ctr = 0;	/*	clear interrupt counter	*/
	underflg = 0;	/*	clear underflow-flag	*/
      

      outportb(TCR2,0xb3);	/*	Timer enable	*/
      outportb(PADR2,int_sss_no); /* sensor select 1996.1.25 by nagasawa*/
      outportb(PACR2,0x28);       /* H2 asert 1996.1.25 by nagasawa*/

      outportb(PACR2,0x22);       /* H2 negate and H1 interrupt enable  1996.1.25 by nagasawa*/
	/*outportb(PACR2,0x7b);*/	/*	interrupt enable	*/
	outportb(VIMR,0x02);	/*	VME IRQ1  enable	*/
       toc=0x3ffff;
	

      while ( sss_ctr < 2 &&  stpflg != ACTIVE &&  underflg == 0 && toc!=0)
	{	

       /*underflg = inportb(PADR2) & 0x04;*/
       toc--;

       }

                                 /* 1995.1.25 by nagasawa*/
	outportb(TCR2,0xb2);	/*	Timer disable	*/
	outportb(VIMR,0x00);	/*	VME IRQ   disable	*/
	outportb(PACR2,0x20);	/*	interrupt disable 1995.1.25	 change by nagasawa */


	/*	get sss data	*/
	h = inportb(CNTR2 +2) & 0xff;
	m = inportb(CNTR2 +4) & 0xff;
	l = inportb(CNTR2 +6) & 0xff;
	dist = (SSS_LIMIT - ( (h<<16) + (m<<8) +l ) ) * 32/(double)8000000 * 340 /2;
	/*	count difference * (1/8MHz) * 32 prescaler * 340 m/s /2 (go & return)	*/

	/*	display sss data	*/
	itostr( (unsigned int)(dist*100),buffer,10);
	rs_snd("\n distance :");
	rs_snd(buffer);
	rs_snd(" cm.\n");

	if ( stpflg == ACTIVE )
	{
		rs_snd("\n STOP \n");
		rs_snd(err_msg);
		/*return;    96.1.18 rem nagasawa*/
	}
       
	underflg = inportb(PADR2) & 0x04;
	if ( underflg != 0 )
	{
		rs_snd("\n  Underflow. \n");
		rs_snd(err_msg);

             /*return;    96.1.18 rem nagasawa*/
	}

       if ( toc==0 )
	{
		rs_snd("\nError!!  Sensor is not connected. \n");
		rs_snd(err_msg);

             /*return;    96.1.18 rem nagasawa*/
	}

	rs_snd("  O.K. \n");
     }
	/*	[5] SSS Underflow Test	*/
	strcpy(err_msg,"\n ---- Check SSS:SSS Underflow Function ---- \n");
	rs_snd("\n [5] SSS Underflow Test \n");
	rs_snd("\n  Input the sensor number >> ");

	/*	select sensor	*/
	int_sss_no = NON;
	while ( int_sss_no == NON && nextflg != ACTIVE && stpflg != ACTIVE )
	{
		int_sss_no = inp();
		if ( int_sss_no < 0 || SSS_MAX < int_sss_no ) int_sss_no = NON;
	}
	nextflg != ACTIVE;
	if ( ret() != 0 ) return;

	sss_ctr = 0;	/*	clear interrupt counter	*/
	underflg = 0;	/*	clear underflow-flag	*/


      outportb(TCR2,0xb3);	/*	Timer enable	*/
      outportb(PADR2,int_sss_no); /* sensor select 1996.1.25 by nagasawa*/
      outportb(PACR2,0x28);       /* H2 asert 1996.1.25 by nagasawa*/

      outportb(PACR2,0x22);       /* H2 negate and H1 interrupt enable  1996.1.25 by nagasawa*/

	outportb(VIMR,0x02);	/*	VME IRQ1  enable	*/
 

      toc=0x3ffff;
	while ( sss_ctr < 2 &&  stpflg != ACTIVE &&  underflg == 0 && toc!=0)
	{	

       /*underflg = inportb(PADR2) & 0x04;*/
       toc--;

       }

                                 /* 1995.1.25 by nagasawa*/

	outportb(TCR2,0xb2);	/*	Timer disable	*/
	outportb(VIMR,0x00);	/*	VME IRQ   disable	*/
	outportb(PACR2,0x20);	/*	interrupt disable 1995.1.25	 change by nagasawa */

	if ( stpflg == ACTIVE ) return;
	if ( underflg == 0 )
	{
		rs_snd("\n  Not underflow. \n");
		rs_snd(err_msg);
		return;
	}
	rs_snd("  O.K. \n");
}


void	sss_init()
{
	/*	PI/T 2	*/
	outportb(PGCR2,0x08);	/*	mode 0		*/
	outportb(PSRR2,0x1c);
	/*outportb(PACR2,0x79);*/	/*	submode 01	*/

       outportb(PACR2,0x20);  	/*	submode 00  1996.1.25 by nagasawa */	
	outportb(PADDR2,0x03);
	outportb(PGCR2,0x18);	/*	mode 0		*/
	outportb(TCR2,0x00);	/*	clear	TCR2	*/
	outportl(CPR2,SSS_LIMIT);	/*	count for ss-wave to go & return 3 meter	*/
	outportb(TCR2,0xb2);	/*	device watchdog		*/

	/*	set vector for interrupt	*/
	asm(
"	MOVEA.L		#$120,A0	*	120(h) = 72(d) * 4 ",
"	MOVE.L		#_sssint,(A0)"
	);

	outportb(PIVR2,72+0);	/*	sss interrupt causes by H1	*/

       outportb(TIVR2,72+0);	/*	sss interrupt causes by tout*/

}


int	sss_sel( sss_no, mode )
int	sss_no;
int	mode;
{
	rs_snd("\n  Supersonic Sensor No.");
	itoa(sss_no,buffer);
	rs_snd(buffer);
	rs_snd(" is selected.");
	rs_snd("\n  Hit return key to start. ( Hit F2 key for next. ) : ");

	nextflg = crflg = !ACTIVE;
	while ( crflg != ACTIVE && nextflg != ACTIVE && stpflg != ACTIVE );
	crflg = !ACTIVE;
	if (nextflg == ACTIVE)
	{
		nextflg = crflg = !ACTIVE;
		return(0);
	}

	switch ( mode )
	{
		case 0:			/*	Test [1],[3]	*/
			rs_snd(" Check the signals. \n");
			break;
		case 1:			/*	Test [2]	*/
			rs_snd(" Listen to the selected sensor.\n");
			break;
		default:
			stpflg = ACTIVE;
			break;
	}
	outportb(PADR2,sss_no);		/*	send signal	*/
	if ( yes() != 0 ) return(1);
	return(0);
}


/*	supersonic wave sensor function	*/
interrupt void	sssint()
{
	outportb(VIMR,0x00);      /* 1995.1.25  change by nagasawa */

       underflg = inportb(PADR2) & 0x04;
       outportb(PACR2,0x20);

       sss_ctr=2;

}